# ReadKeyValueCacheRepo

open class ReadKeyValueCacheRepo < Key , Value >(parentRepo: ReadKeyValueRepo < Key , Value >, kvCache: KVCache < Key , Value >, locker: SmartRWLocker = SmartRWLocker()) : ReadKeyValueRepo < Key , Value > , CommonCacheRepo (source)

#### Inheritors

KeyValueCacheRepo

## Constructors

ReadKeyValueCacheRepo
Link copied to clipboard
constructor(parentRepo: ReadKeyValueRepo < Key , Value >, kvCache: KVCache < Key , Value >, locker: SmartRWLocker = SmartRWLocker())

## Functions

asReadCRUDRepo
Link copied to clipboard
fun < K , V > ReadKeyValueRepo < K , V >. asReadCRUDRepo (): ReadCRUDFromKeyValueRepo < V , K >
asReadKeyValuesRepo
Link copied to clipboard
fun < K , V , VI : Iterable < V >> ReadKeyValueRepo < K , VI >. asReadKeyValuesRepo (): ReadKeyValuesFromKeyValueRepo < K , V , VI >
cached
Link copied to clipboard
fun < Key , Value > ReadKeyValueRepo < Key , Value >. cached (kvCache: KVCache < Key , Value >, locker: SmartRWLocker = SmartRWLocker()): ReadKeyValueCacheRepo < Key , Value >
fun < Key , Value > ReadKeyValueRepo < Key , Value >. cached (kvCache: KeyValueRepo < Key , Value >, locker: SmartRWLocker = SmartRWLocker()): FullReadKeyValueCacheRepo < Key , Value >
contains
Link copied to clipboard
open suspend override fun contains (key: Key ): Boolean
count
Link copied to clipboard
open suspend override fun count (): Long
diff
Link copied to clipboard
suspend fun < Id , Registered > ReadKeyValueRepo < Id , Registered >. diff (other: Map < Id , Registered >): MapDiff < Id , Registered >
directlyCached
Link copied to clipboard
fun < Key , Value > ReadKeyValueRepo < Key , Value >. directlyCached (kvCache: KeyValueRepo < Key , Value >, locker: SmartRWLocker = SmartRWLocker()): DirectFullReadKeyValueCacheRepo < Key , Value >
get
Link copied to clipboard
open suspend override fun get (k: Key ): Value ?
getAll
Link copied to clipboard
open suspend override fun getAll (): Map < Key , Value >
invalidate
Link copied to clipboard
open suspend override fun invalidate ()

Invalidates its internal data. It may lead to autoreload of data. In case when repo makes autoreload, it must do loading of data before clear

keys
Link copied to clipboard
open suspend override fun keys (pagination: Pagination , reversed: Boolean ): PaginationResult < Key >

This method should use sorted by Keys search and return the PaginationResult. By default, it should use ascending sort for Keys

open suspend override fun keys (v: Value , pagination: Pagination , reversed: Boolean ): PaginationResult < Key >

This method should use sorted by Keys search and return the PaginationResult. By default, it should use ascending sort for Keys.

maxPagePagination
Link copied to clipboard
inline suspend fun ReadKeyValueRepo <*, *>. maxPagePagination (): SimplePagination
values
Link copied to clipboard
open suspend override fun values (pagination: Pagination , reversed: Boolean ): PaginationResult < Value >

This method should use sorted by Keys search and return the PaginationResult. By default, it should use ascending sort for Keys

withMapper
Link copied to clipboard
inline fun < FromKey , FromValue , ToKey , ToValue > ReadKeyValueRepo < ToKey , ToValue >. withMapper (mapper: MapperRepo < FromKey , FromValue , ToKey , ToValue >): ReadKeyValueRepo < FromKey , FromValue >
inline fun < FromKey , FromValue , ToKey , ToValue > ReadKeyValueRepo < ToKey , ToValue >. withMapper (noinline keyFromToTo: suspend FromKey .() -> ToKey = { this as ToKey }, noinline valueFromToTo: suspend FromValue .() -> ToValue = { this as ToValue }, noinline keyToToFrom: suspend ToKey .() -> FromKey = { this as FromKey }, noinline valueToToFrom: suspend ToValue .() -> FromValue = { this as FromValue }): ReadKeyValueRepo < FromKey , FromValue >